package functionalDependency.general;

/**
 * Diese Klasse stellt Fehlercodes zur Verfuegung. Sie ist von der
 * Fehlerklasse {@link Exception} abgeleitet.
 * <p>Im Rahmen der Aufgabenstellung muss in dieser Klasse nichts geaendert werden.</p>
 */
public class MainException extends Exception {

	static final long serialVersionUID = 1L;
	private int errorCode;

	public MainException() {
		super();
	}

	public MainException(String arg0) {
		super(arg0);
		errorCode = 0;
	}

	public MainException(String arg0,int code) {
		super(arg0);
		setErrorCode(code);
	}

	public MainException(String arg0, Throwable arg1) {
		super(arg0, arg1);
		errorCode = 0;
	}

	public MainException(Throwable arg0) {
		super(arg0);
		errorCode = 0;
	}

	public int getErrorCode(){
		return errorCode;
	}

	public void setErrorCode(int code){
		if(code<=0)
			throw new RuntimeException("invaild error code: " + code);
		errorCode = code;
	}
}
