package functionalDependency.parser;

import functionalDependency.general.MainException;

/**
 * Diese Klasse stellt Fehlercodes fuer das Arbeiten mit dem Parser
 * zur Verfuegung. Sie ist von der Hauptfehlerklasse {@link MainException}
 * abgeleitet.
 * <p>Im Rahmen der Aufgabenstellung muss in dieser Klasse nichts geaendert werden.</p>
 */
public class ParserException extends MainException {

	static final long serialVersionUID = 2L;
	
	public static final int YACC_ERROR = 1;
	public static final int LEX_ERROR = 2;
	public static final int ATTR_ERROR = 3;
	public static final int FD_ERROR = 4;
	
	public ParserException() {
		super();
	}

	public ParserException(String arg0) {
		super(arg0);
	}

	public ParserException(String arg0, Throwable arg1) {
		super(arg0, arg1);
	}

	public ParserException(Throwable arg0) {
		super(arg0);
	}

	public ParserException(String arg0,int code) {
		super(arg0,code);
	}
}
